# -*- coding: cp1252 -*-
#!/usr/bin/env  python
# ==================================================================
#    Plot_Velocity_Comparison.py 
# 
# ==================================================================
# ======================================
# by Ph. MARON, 29th February 2012
# ======================================
"""
    This sript plots the comparison between velocity values at different 
    location from different hdf5 files. location is pointed on a map.
"""
import sys
#sys.path.append("C:\Python27\Lib\Mohid")
sys.path.append("E:\Phil_Recherche\Programmes\Python\Z_Final\Class")

import hdf5files
from hdf5files import Hdf5
import mohidfiles
import matplotlib.pyplot as plt
import matplotlib.image as image
from matplotlib.path import Path
from matplotlib.patches import PathPatch
import matplotlib.tri as tri
from pylab import *
from pylab import array


print'=================================================================='
print'!   PROGRAMME : Plot_Velocity_Comparison.py                        !'
print'=================================================================='


# ===== read parameters file ===========================================
inputfile=open ('Plot_Velocity_Comparison_Param.dat','r')

try :
    file=inputfile.readlines()
finally :
    inputfile.close

i=0
while i<len(file):
    # reading the line
    line=file[i].strip('\n')
    line=line.strip(' ')
    if (len(line)>0):
        if  (line[0]<>'#'):
            word = line.split(':')
            keyword = word[0].strip(' ')
            if len(word)>1:
                word=word[1].strip(' ')
            if keyword=='DISK_FILE':
                disk_file=word +':'
            elif keyword=='FILE_PATH_INPUT':
                file_path_input=word
            elif keyword=='<begin_file>':
                begin_file=i
            elif keyword=='<end_file>':
                end_file=i            
            elif keyword=='FILE_PATH_MAP':
                file_path_map=word
            elif keyword=='FILE_NAME_MAP':
                file_name_map=word
            elif keyword=='FILE_PATH_MASK':
                file_path_mask=word
            elif keyword=='FILE_NAME_MASK':
                file_name_mask=word
            elif keyword=='FILE_PATH_OUTPUT':
                file_path_output=word
            elif keyword=='FILE_NAME_OUTPUT_BEGIN':
                file_name_output_begin=word
            elif keyword=='<begin_location>':
                begin_location=i
            elif keyword=='<end_location>':
                end_location=i            
            elif keyword=='VECTOR_WIDTH':
                vector_width=float(word)
            elif keyword =='VECTOR_SCALE_VALUE':
                vector_scale_value=float(word)
    i=i+1

# ========== read file names ===================================================
files=[]
for i in range(begin_file+1,end_file):
    line=file[i].strip('\n')
    line=line.strip(' ')
    if (len(line)>0):
        if  (line[0]<>'#'):
            word=line.strip(' ')
    files.append(word)
# n=raw_input('Type to follow !')
# ========== read longitude and latitude values ================================
location=[]
strlocation=[]
for i in range(begin_location+1,end_location):
    line=file[i].strip('\n')
    line=line.strip(' ')
    if (len(line)>0):
        if  (line[0]<>'#'):
            word = line.strip(' ')
            while '  ' in word:
                    word= word.replace('  ',' ')
            word =word.split(' ')
            location.append([float(word[0]), float(word[1])])   
            strlocation.append([word[0],word[1]]) 
location=array(location)
strlocation=array(strlocation)
#n=raw_input('Type Enter to continue !')

# ===== print parameters ===================
print 'DISK_FILE   :  ',    disk_file
print 'FILE_PATH_INPUT   :  ',    file_path_input
print 'files : ', files
print 'FILE_PATH_MAP   :  ',    file_path_map
print 'FILE_NAME_MAP   :   ',  file_name_map
print 'FILE_PATH_MASK   :  ',    file_path_mask
print 'FILE_NAME_MASK   :   ',  file_name_mask
print 'FILE_PATH_OUTPUT   :  ',    file_path_output
print 'FILE_NAME_OUTPUT_BEGIN   :  ',    file_name_output_begin
print 'location  :  ', location
print'VECTOR_WIDTH : ', vector_width
print'VECTOR_SCALE_VALUE : ', vector_scale_value

print'_____________________________'
    
#n=raw_input('Type Enter to continue !')

# => Open hdf5 files =======================================
for f in range(len(files)):
    f_file=Hdf5(disk_file+file_path_input+files[f])
    print 'read ',files[f]
    
s_file=Hdf5( disk_file+file_path_map+file_name_map)   
#n=raw_input('Type Enter to close !')

# => create plot ===========================================
for xy in range(location.shape[0]):
    xr=location[xy,0]
    yr=location[xy,1]
    print    
    print 'location : '+ strlocation[xy,0]+' W '+strlocation[xy,1]+' N'
    
    # === plot figure
    figsize =18,10
    fig=figure(figsize=figsize)
    plt.subplots_adjust(left  = 0.05,right = 0.95, bottom = 0.08, top = 0.95,wspace = 0.2,hspace = 0.5)

    # === add map
    ax =fig.add_subplot(1,2,1)
    CS=ax.contourf(s_file.coordlon,s_file.coordlat,s_file.bathymetry, 1000)#,linewidths=0.5, levels=[20,22,24,26,28,30,32,34,35])

    plot(xr,yr,'ro')

    title('location : '+ str(xr)+' W '+str(yr)+' N')
    xlabel('Longitude', size='smaller')
    ylabel('Latitude', size='smaller')
    xlim(-1.85,-1.30)
    ylim(43.35,44.05)
    
    # === map mask =================================================
    file5=mohidfiles.Polygons(disk_file+file_path_mask+file_name_mask)
    for i in range ( file5.vertice.shape[0]):
        vertices = array(file5.vertice[i])
        codes = []
        codes = [Path.MOVETO] + [Path.LINETO]*(vertices.shape[0]-2)+ [Path.CLOSEPOLY]
        path = Path(vertices, codes)
        
        pathpatch = PathPatch(path, facecolor='grey', edgecolor='grey')
        ax.add_patch(pathpatch)

    # == fill arrays ===========================================
    f0= Hdf5(disk_file+file_path_input+files[0])
    val_time=sorted(list(set(f0.date2num))) 
    nbt=f0.nbtime
    gri_time=zeros(((nbt+1)*len(files)))
    gri_y=zeros((nbt+1)*len(files))
    gri_U=zeros(((nbt+1)*len(files)),float)
    gri_V=zeros(((nbt+1)*len(files)),float)
#    n=raw_input('Type Enter to close !')
    
    for f in range(len(files)):
        if xy==0:
            f_file=Hdf5(disk_file+file_path_input+files[f])
        
        nbf=f_file.nbtime
        print 'fill array from ',files[f]    
    
        # => latitude location in father grid  ==========================
        for y in range(f_file.latitude.shape[1]):    
            if float(f_file.latitude[0,y])<=float(yr)<float(f_file.latitude[0,y+1]):
                f_yi=y
                break
        # => longitude location in father grid  ==========================
        for x in range(f_file.longitude.shape[0]):
            if float(f_file.longitude[x,0])<=float(xr)<float(f_file.longitude[x+1,0]):
                f_xi=x
                break
        # === plot file velocities
        val_time_=sorted(list(set(f_file.date2num)))
        deltatime=f_file.date2num[-1]-f_file.date2num[0]
        mediumtime=(f_file.date2num[-1]+f_file.date2num[0])/2.

        gri_time[(nbf+1)*f:(nbf+1)*(f+1)-1]=val_time_
        gri_time[(nbf+1)*(f+1)-1]=mediumtime
 
        gri_y[(nbf+1)*f:(nbf+1)*(f+1)-1]=-f
        gri_y[(nbf+1)*(f+1)-1]=-f+0.3

        gri_U[(nbf+1)*f:(nbf+1)*(f+1)-1]=f_file.velocity_u[:,0,f_xi,f_yi]
        gri_U[(nbf+1)*(f+1)-1]= vector_scale_value

        gri_V[(nbf+1)*f:(nbf+1)*(f+1)-1]=f_file.velocity_v[:,0,f_xi,f_yi]
        gri_V[(nbf+1)*(f+1)-1]=0

    # == plot velocities ===========================================    
    plt2=subplot(1,2,2)

    M = sqrt(pow(gri_U, 2) + pow(gri_V, 2))
    Q=plt2.quiver(gri_time, gri_y, gri_U, gri_V, M, units='xy', width= vector_width)
    title('Velocity versus time at '+ str(xr)+' W '+str(yr)+' N')
    for f in range(len(files)):
        print 'plot ',files[f]  

        # ==== vector legend        
        plt2.text(mediumtime,-f+0.33,str(vector_scale_value)+' m/s',size='smaller')
        # ==== title
        plt2.text(f_file.date2num[0],-f+0.40,files[f]+' velocity at '+ str(xr)+' W '+str(yr)+' N')#,size='smaller')
      
        xlim(f_file.date2num[0]-0.2*deltatime, f_file.date2num[-1]+0.2*deltatime)
        formatter = DateFormatter('%m/%d %H:%M')
        plt2.xaxis.set_major_formatter(formatter)
        labels = plt2.get_xticklabels()
        setp(labels, rotation=15,size='smaller')
        
        ylim(-(f+0.5),0.5)
        plt2.yaxis.set_visible(False)

        grid(True)


    # === Insert logo ======================================
    im = image.imread('C:\Python26\Lib\Mohid\Logo_UPPA-SIAME_109-50.png')
    fig.figimage(im, 5, 5)# les deux chiffres determinent la position du coin de l image / origine de l'image
    
    # === Save figure =====================================
    print 'Create Figure '+file_name_output_begin+'_'+  strlocation[xy,0]+'W '+strlocation[xy,1]+'N'+'.png'
    print'______________________________________'

    record_name=disk_file+file_path_output+file_name_output_begin
    fig.savefig(record_name+'_'+  strlocation[xy,0]+'W '+strlocation[xy,1]+'N'+'.png')


# == END OF SCRIPT ==============================================================
print '========================================================================'
print '  END OF : Plot_Velocity_Comparison.py                                   !'
print '========================================================================'
#n=raw_input('Type Enter to close !')


